
      subroutine open_files 
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm'
      
      open(24, file= 'Additional_Potential.out')  
        write(24,2424, advance='no') "t", "ibox", "V"
2424    format ( 10x,A,  10x,A, 15x,A)
        write (24,*) "   "   
       

      open (unit=65, file='rc_me_tot.out')
      write(65,*) "matrix of rate constants"
      close(65)

      open(unit=67, file='rc_me.out')
      write(67,*) "matrix of rate constants"
      close(67)
      

!     This is the output files for DS
      
      open (unit=797, file='free_energy.out')
      open (unit=798, file='p.out')
      open (unit=799, file='average_Gtot.out')
      open (unit=800, file='force.out')
      
      return
      end



      subroutine input_rc
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm'

!     Input of the rate constants
!
!     This subroutine has been modified on the 19.05.2020 to tead from the file r_c_fnl.out produced in the directory HR_RC_1_HR_3_modified_1
!
!
c      open 
c     &(file='I27_k_up.txt', unit=51) 
c      open 
c     &(file='I27_k_down.txt',unit=52)  
c      open 
c     &(file='I27_bounds.txt', unit=53)  

!      Parameters

       R = 8.314459              !J mol-1 K-1
       Temp=298.0                ! K
!

       epsilon_p=1.0d-100          !limit of lowest population value
!
!      Hook's law force constant
! 
       
       open (file='fc_v.inp',unit=591)
       read(591,*) force_constant
       read(591,*) v
       read(591,*) potential_max
       read(591,*) R_flat_min
       read(591,*) R_flat_max
       read(591,*) R_flat_min_2
       read(591,*) R_flat_max_2
       read(591,*) factor_rc_up          ! rc_up   will be multiplied by this factor
       read(591,*) factor_rc_down        ! rc_down will be multiplied by this factor
       
       
!       
!       force_constant= 1.  !3  !1        !20       !200  !20                  ! pN/A
!
!      and maximal additional Hook's law tip energy to avoid very large and very small elements in the rate constants matrix.        
!       
c       potential_max=200.0d0 !1000 !200                   ! potential max in kJ/mole
c           NOW potential_max is taken from 'fc_v.inp'
c       
c       
       potential_max=potential_max*1000    ! potential_max in J/mole as required by calculating potential subroutine
       a_split=10   !100
       a_split=a_split*1000                !  a_split  in J/mole as required by calculating potential subroutine
c
c       
c       R_flat_min=10.00  !20.0d0       !   30.0d0                           ! R_flad tells where PMF becomes flat
c       R_flat_max=100.00
c
c        NOW R_flat_min and R_flat_max are taken from 'fc_v.inp'
c
c       
       !
!      Pulling speed 
!       
       

       


       !v=3870000                         ! Velocity in A/unit_of_time   The unit of time in nanosecond, which is 10-9.
       ! v=0.01                  ! Then 1.0 A/ns=0.1 m/s = 10^5 micrometers/sec   v=0.01 A/ns = 10^3 micrometers/sec,v=10.d3 A/ns=100 m/sec   
                                          ! The experimental velocities range from 10^-2 to 10^3 micrometers/sec  So in our units v is up to 0.01 A/ns

       
!       
!      Here we calculate dt_out from maximal extension, velocity v and number of steps n_out      
!
!      FROM INPUT FILE NOW

       read (591,*)  extension_max
       read (591,*)  n_out
       read (591,*)  n_out_equilibration
       read (591,*)  dt_out_equilibration

       
!       extension_max       = 70.   ! =100.0d0       ! Maximal extension, A
!       n_out               =300   !500   
!       n_out_equilibration =5   
       
       k_out               =20       
       dt_out=((extension_max/v) / n_out) ! A/A ns-1 = ns

!       dt_out_equilibration=50.00 ! Time step for equilibration in ns
              
      close (unit=591)

      open (file='r_c_fnl.out', unit=54)

      rc_total=0.0d0
      
            
      do ibox=1,  nbox_tot-1  !nboxsmall
      read (54,515) inp_ibox, inp_ibox_plus_1, 
     &              inp_ibox, inp_ibox_plus_1, 
     &   boxcentre_inp_ibox,  boxcentre_inp_ibox_plus_1,
     &   rc_r_to_l_inp,  rc_l_to_r_inp      
!
!
!     Modifying rate constants up and dow by a factor
!      
!      
      box_center_tot(ibox)=boxcentre_inp_ibox
      box_bound_tot(ibox)=boxcentre_inp_ibox-
     &      (boxcentre_inp_ibox_plus_1-boxcentre_inp_ibox)/2
 
      
      
      if ((box_center_tot(ibox)-box_center_tot(1)).lt.R_flat_max) 
     &                                                            then      
      rc_r_to_l_inp=rc_r_to_l_inp*factor_rc_down
      rc_l_to_r_inp=rc_l_to_r_inp*factor_rc_up     
      end if
            
      



!      
!     Here we make the free energy / PMF flat R > R_flat
!      
!     if (box_bound_tot(ibox).gt. (box_bound_tot(1)+R_flat))  then 
      
      iflag_flat=0
      if 
     &((box_bound_tot(ibox).gt. (box_bound_tot(1)+R_flat_min))  .and.  
     & (box_bound_tot(ibox).lt. (box_bound_tot(1)+R_flat_max)) ) then
      iflag_flat=1
      end if
      
      if 
     &((box_bound_tot(ibox).gt. (box_bound_tot(1)+R_flat_min_2)) .and.  
     & (box_bound_tot(ibox).lt. (box_bound_tot(1)+R_flat_max_2))) then
      iflag_flat=1
      end if      
      
!     & ( (box_bound_tot(ibox).gt. (box_bound_tot(1)+R_flat_min_2)) .and.  
!     &  (box_bound_tot(ibox).lt. (box_bound_tot(1)+R_flat_max_2)) )      
  
     
      
      if (iflag_flat.eq.1) then           
        rc_avrg_inp=dsqrt(rc_l_to_r_inp*rc_r_to_l_inp)
        rc_l_to_r_inp=rc_avrg_inp
        rc_r_to_l_inp=rc_avrg_inp
      end if
      
!     if (ibox.ge.nbox) then
      
      rc_total(ibox,ibox+1)=rc_l_to_r_inp          !rc_up
      rc_total(ibox+1,ibox)=rc_r_to_l_inp                !rc_down

!     end if
      
      end do
!
!
!    Two more boxes
!     
!      
      box_bound_tot(nbox_tot)=box_bound_tot(nbox_tot-1)
     &     + (boxcentre_inp_ibox_plus_1-boxcentre_inp_ibox)
      box_bound_tot(nbox_tot+1)=box_bound_tot(nbox_tot)
     &     + (boxcentre_inp_ibox_plus_1-boxcentre_inp_ibox)
      

 515  format(4(1x,i4),2(1x,f12.5),2(1x,e12.5))

      
       r0=  box_center_tot(1)    !r0 is chosen at the centre of the box 1, A 
      
      
c!    read box boundss
c
c      do ibox=1,nbox_tot+1
c      read (53,*) b_b
c      box_bound_tot(ibox)=b_b                         
c      end do
c      close (unit=53)
c
c!    calculate box centre

      do ibox=1,nbox_tot
      box_center_tot(ibox)
     &      =(box_bound_tot(ibox)+box_bound_tot(ibox+1))/2.0d0  !A
      end do     

      r0=  box_center_tot(1)    !r0 is chosen at the centre of the box 1, A 
      
c!     read rate constants up and create box-to-box matrix elements for going up
c
c      do ibox=1,nbox_tot-1
c        read (51,*) rc_up
c        rc_total(ibox,ibox+1)=rc_up
c      end do
c      close (unit=51)     
c
c!     read rate constants up and create box-to-box matrix elements for going down
c
c      do ibox=1,nbox_tot-1
c        read (52,*) rc_down
c        rc_total(ibox+1,ibox)=rc_down
c      end do
c      close (unit=52)    
c
c!    convert units of unmodified rate constants into ns-1
c


      rc_total=rc_total/2.0d0    ! converting to fs**(-1) instead of 1/(2fs)
      rc_total=rc_total*1d6      ! converting from fs**(-1) to ns**(-1)
                                 ! indeed, 1fs=10**(-6)*1ns then 1ps**(-1) = 1ns**(-1)*10**6      
      rc_tot=rc_total            



      return
      end





      subroutine calculate_GBXD
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm' 

!     Calculate equilibrium constant and delta G going into box ibox

      do ibox=2, nbox_tot        
        rc_up =rc_total(ibox-1,ibox)  !rc_total is unmodified array of rate constant
        rc_down=rc_total(ibox,ibox-1)          
        e_cnstnt(ibox) = rc_up/rc_down !unitless           
        delta_G(ibox) = -R*Temp*log(e_cnstnt(ibox)) !J mol-1
      end do

!     Calculate G for each box as the sum of the previous G value plus deltaG for entering box ibox    

      G(1)= 0.0d0
      do ibox= 2, nbox_tot
        G(ibox) = G(ibox-1) + delta_G(ibox)
        G(ibox)=G(ibox)                     ! J mol-1
      end do

!    Sum G and potential, Jmol-1     

      do ibox =1,nbox_tot
        G_plus_V(ibox) = G(ibox) + (potential(ibox))     !J mol-1 + J mol-1 = J mol-1
      end do         
      
      return
      end



! Calculate the total free energy of the system averaged over the populations, J mol-1

      subroutine calculate_Gtot(avarage_G_plus_V,avarage_G)
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm'

      avarage_G_plus_V = 0.0d0
      avarage_G        = 0.0d0      
      do ibox=1,nbox_tot  
        avarage_G_plus_V=avarage_G_plus_V + G_plus_V(ibox)*p_tot(ibox) !G_times_pop(ibox)
        avarage_G       =avarage_G + G(ibox)*p_tot(ibox)
      end do 
      write (799,4) delt, extension, avarage_G_plus_V
4     format (2(f12.4),  e16.8)


      return
      end

 
