      program t_to_0
      implicit doubleprecision (a-h,o-z)       
      include 'arrays2.cm' 

!     Open files and read the rate constants.        
      
      call open_files
      call input_rc
     
!     Set initial distribuytion p0(nbox_tot)
      
      call set_initial_p
      p_tot=p0


!     Equilibration  loop:

      delt=0.0d0      
      call create_m_matrix
      call calculate_GBXD

!     Doing equilibration you do not need to solve master equation matrix at every time step.  
!     You also do not need to create small matrix at every step. It is done only once
          
      call create_small_distribution(nmin,nmax)   
      call create_small_m_matrix(nmin,nmax)           
         
      call solve_master_equation_mtrx          

!     Equilibration by "propagation"

      do i= 1,n_out_equilibration
          
          do i_p_box=1,nbox_tot                        !current population of each box for this time step
          if (dabs(p_tot(i_p_box)).le.0.0d0) then
            p_tot(i_p_box)=0.0d0
          end if
          p_step(i_p_box,i+1)=p_tot(i_p_box)
        end do

          
          
          write (*,*) 'i_equilibration=',i
          call calculate_populations_and_its_drvtv(dt_out_equilibration) !(delt)
      end do

!     You need to create total distribution only once after the equilibration

      call create_total distribution(nmin,nmax)  

!     End of equilibration.               


!     Now we start the srtep-by-step Kinetics:
!     Evolution of pre-equilibrated distribution. The rate coefficients will be modified at each step.             


!     Saving all information about population and extension into p_step and r_tip
      do i_p_box=1,nbox_tot
        if (dabs(p_tot(i_p_box)).le.epsilon_p) then
          p_tot(i_p_box)=0.0d0
        end if
        p_step(i_p_box,1)=p_tot(i_p_box)
      end do

!     Initial position of the tip

      extension=0.0d0
      r_tip(1)=extension
      average_g=0
      i_count=0           

!     Here we calculate G_plus_V averaged over the distribution and load it into the array G_plus_V_avrg.

      call calculate_Gtot(average_G_plus_V,average_G)
      G_plus_V_avrg(1)= average_G_plus_V
      G_avrg(1)       = average_G

!     Now we start the kinetic evolution for n_out steps

      do i= 1,n_out
        write (*,*) 'i=' , i, 'extension',extension
        delt= dt_out*i  !(i-1)  
        call modify_potential
        call modify_rc(deltat)
        call create_m_matrix   !using modified rcs
        ninit =1


!     We call calculate_GBXD now as it also calculates G+V with our modified rcs

        call calculate_GBXD

!    Create distribution, solve KME to get box populations 

        call create_small_distribution(nmin,nmax)   ! get distribution for fewer boxes
        call create_small_m_matrix(nmin,nmax)       ! select boxes we want
        call solve_master_equation_mtrx             ! get eigenvalues and eigenvectors
        call calculate_populations_and_its_drvtv(dt_out) !get populations 
        call create_total distribution(nmin,nmax)   ! Pop distribution for our selection of boxes in matrix

        extension = v*delt                         ! extension at time t A/ns * ns = A


!     This subroutine calculates G_pluS_V averaged oder the distribution 

        call calculate_Gtot(average_G_plus_V,average_G) !G_plus_V averaged over the distribution
        G_plus_V_avrg(i+1)= average_G_plus_V         ! Assign this to I+1 so first time have this will 
        G_avrg(i+1)       = average_G                !be for step 2 after first modification of res

!    Saving all information about population and extension into p_step and r_tip

        do i_p_box=1,nbox_tot                        !current population of each box for this time step
          if (dabs(p_tot(i_p_box)).le.epsilon_p) then
            p_tot(i_p_box)=0.0d0
          end if
          p_step(i_p_box,i+1)=p_tot(i_p_box)
        end do

        r_tip(i+1)=extension                         !current extension this time step

        i_count=i_count+1                            !print out p and G every k_out steps
        if (i_count.eq.k_out) then
          call output_p_and_G
          i_count=0
        end if

        p=p                       !make sure population is population for start of next time step

      end do    ! do i= 1,n_out

!     Now we will figure out the force and the maximal force in several ways, Hook's law and differential of PMF

      call calc_out_force              

      stop
      end
