
!      This file contains subroutines which solve master equation and create matrixes and populations. 
	
	
       subroutine solve_master_equation_mtrx

!      This subroutine solves Master equation by finding the eigen values and eigen vectors of the Master Equation matrix
	 
       implicit doubleprecision (a-h,o-z)       
       include 'arrays2.cm'       
       
       N     = nbox
       LDA   = nbox
       
       LDB   = nbox
       LDVL  = nbox
       LDVR  = nbox
       JOBVL = 'N'
       JOBVR = 'V'

!      The matrix of rate constants
       
       A     = rc_me ! Matrix of rcs where diagonal is -kdown-kup
       LWORK = 8*nbox+1000
       
       B=0.0d0
       do i=1,nbox
       B(i,i)=1.0d0
       end do
       
       call DGGEV( JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHAR, ALPHAI,
     $                  BETA, VL, LDVL, VR, LDVR, WORK, LWORK, INFO )
     
       open (file='eigen_vector.out', unit=11,  access ='sequential',
     &  position ='append', action='write')   
       open (file='eigen_value.out',  unit=12, access ='sequential',
     &  position ='append', action='write')   

! Write eigenvalues to file       
       
c       write(12,*) "deltat =", delt
c       write(12,*)"    "
       do i=1,nbox
!       write (12,1212) i,ALPHAR(i), ALPHAI(i), BETA(i), -1.0d0/ALPHAR(i)
 1212  format (1x,i4, 4(2x,e12.5))
       end do
c       write(12,*) "    "
      
! Write eigenvectors to file  
      
c       write(11, *) "deltat=", delt
c       write(11,*) " rc_me    "  
c          
c       do i=1,nbox
c        do j=1,nbox 
c         write (11,1111) rc_me(i,j)
c        end do
c       write (11,*) ' '
c       end do
c       write (11,*) ' '
c       write(11,*) "  VR   "  
c       do i=1,nbox
c        do j=1,nbox 
c         write (11,1111) VR(i,j)
c 1111     format (1x,e12.5,$)
c        end do
c       write (11,*) ' '
c       end do
c       write (11,*) ' '
c       

!      Checking the norm
       
       do i=1,nbox
        anorm=0.0d0
        do j=1,nbox
         anorm=anorm+VR(j,i)**2
        end do
!        write (11,*) i,anorm
       end do
!        write (11,*) ' '
       
       do i=1,nbox
       do j=1,nbox
        ovrlp=0.0d0
        do k=1,nbox
         ovrlp=ovrlp+VR(k,j)*VR(k,i)
        end do
        ovrlp_ev(i,j)=ovrlp
       end do
       end do
       
c       do i=1,nbox
c        do j=1,nbox
c         write (11,1111) ovrlp_ev(i,j)
c        end do
c       write (11,*) ' '
c       end do
c       write (11,*) ' '      
      
       
       close (12)
       close (11)       

!
!     Figure out the coefficients
!

!
!     Here we calculate equilibrium distribution.  p_eqlbrm 
!     and subtract it form p.  We will add it back later 
!

!
!     call get_p_eqlbrm
!
      p_eqlbrm=0.0d0


      do i=1,nbox
!          
!   Now dp is the deviation from equilibrium !
!          
       dp(i)=p(i)-p_eqlbrm(i)   
      end do
      
      Binp=dp
      
      A=VR
      N=nbox
      NRHS=1
      Binp=dp
      LDB=nbox
      
      call DGESV( N, NRHS, A, LDA, IPIV, Binp, LDB, INFO )      
      
      c=Binp
      return 
      end



      
      subroutine calculate_populations_and_its_drvtv(deltat)
      implicit doubleprecision (a-h,o-z)       
      include 'arrays2.cm'

!     Knowing the outcome of the subroutine solve_master_equation_mtrx 
!     this subroutine calculates populations after time delta_t . 
   
            
      do i=1,nbox
       dpt(i)=0.0d0
       dptdt(i)=0.0d0
       do  j=1,nbox
           
           exp_ALPHAR_t=1  !0.0d0
        if ( dabs(ALPHAR(j)).gt.1.0d-10 )  then!.and.(dabs(ALPHAR(j)*delt)                                           
           exp_ALPHAR_t=dexp(ALPHAR(j)*delt) 
        end if         
           
           !=0.0d0   ! 
!         if (ALPHAR(j).ge.0.0d0) then                   
!           exp_ALPHAR_t=1.0d0 !dexp(ALPHAR(j)*delt)    !0.0d0   
!         else
!           exp_ALPHAR_t=dexp((ALPHAR(j))*delt)      
!         end if 
         dpt(i)=dpt(i)+c(j)*VR(i,j)*exp_ALPHAR_t                !
         dptdt(i)=dptdt(i)+c(j)*VR(i,j)*ALPHAR(j)*exp_ALPHAR_t  
        end do
        dptdt(i)=dptdt(i)/(1.0d0-dpt(i))  !j
      end do     !i      
      
      p=dpt+p_eqlbrm 
   
!      do ibox=1,nbox
!        if (p(ibox).le.epsilon_p) then
!            p(ibox)=0.0d0
!        end if
!      end do       
            
      do ibox=1,nbox
      
      if (p(ibox).le.1.0d-5) then
          p(ibox)=0.0d0
      end if
      
      end do
   
      p_norm=0.0d0
      do ibox=1,nbox
        p_norm=p_norm+p(ibox)
      end do
      write (*,*) 'p_norm=', p_norm
      if (dabs(p_norm).ge.10.0d0) then
        continue
        pause
        stop
      end if


!     write to files
      
      open(unit = 98, file = 'box_populations.out',access ='sequential',
     &  position ='append', action='write')   
      open(unit= 97, file='box_populations_derivatives.out', 
     & access ='sequential', position ='append', action='write')   
      
      
      
      write(98,*) "deltat = ", delt
      do i= 1, nbox
        write(98, 9898) dpt(i)
 9898   format ( 2x, e12.5, 2x, $)
      end do
      write (98,*) '  '
      close(98)

      write(97,*) "deltat = ", delt
      do i= 1, nbox  
        write(97, 9797)  dptdt(i)
 9797   format ( 2x, e12.5, x $)
      end do
      write(97,*) '   '
      close(97)
      
      return
      end





      subroutine create_small_distribution (nmin,nmax)
      implicit doubleprecision (a-h,o-z)       
      include 'arrays2.cm'   

!     Create distribution for smaller number of boxes
      
      pmax=0.0d0
c      iboxmax=0
c      do ibox=1,nbox_tot          
c        if (p_tot(ibox).gt.pmax) then    
c          iboxmax=ibox
c          pmax=p_tot(ibox)
c        end if    
c      end do    
c      
c      nmin=iboxmax-nboxsmallplus
c      nmax=iboxmax+nboxsmallplus
c      
c      if (nmin.lt.1) then
c          nmin=1
c          nmax=nmin+2*nboxsmallplus
c      end if   
c      
c      if (nmax.gt.nbox_tot) then
c          nmax=nbox_tot
c          nmin=nmax-2*nboxsmallplus
c      end if
      
      nmin=1
      nmax=nbox
      
      do ibox=nmin,nmax
          p(ibox-nmin+1)=p_tot(ibox)
      end do
            
      return
      end




	
      subroutine create_small_m_matrix  (nmin,nmax)                
      implicit doubleprecision (a-h,o-z)       
      include 'arrays2.cm'        
    

       rc_me=0.0d0
      
      do ibox=nmin,nmax
        do jbox=nmin,nmax    
          rc_me(ibox-nmin+1,jbox-nmin+1)=rc_me_tot(ibox,jbox)
        end do
      end do
     
      rc_me(1,1)      =-rc_tot(nmin,nmin+1)               !-rc_tot(1,2)
      rc_me(nbox,nbox)=-rc_tot(nmax,nmax-1)               !-rc_tot(nbox,nbox-1)           

      
      return
      end




	
      subroutine create_total distribution(nmin,nmax)
      implicit doubleprecision (a-h,o-z)       
      include 'arrays2.cm'             
	
      p_tot=0.0d0
      
      do ibox=nmin,nmax
        p_tot(ibox)=p(ibox-nmin+1)
      end do
      return
      end




  
      subroutine modify_rc (deltat)
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm'

      do ibox = 1, (nbox_tot-1)           
          deltaV(ibox, ibox+1) =
     &    potential(ibox)-potential(ibox+1)   ! J mol-1             
          write(25,2523)  delt,ibox, deltaV(ibox,ibox+1)
2523      format(e12.2,1x,i,3x,e16.8)  
       end do

!     modify rate constants for going up    
!     deltaV in J mol-1, R in J K-1 mol-1, Temp in K, exponential is unitless 
     
      do ibox = 1,nbox_tot-1 
          exp_bltzmn=exp(deltaV(ibox,ibox+1)/(2*R*Temp))
          rc_tot(ibox, ibox+1)= (rc_total(ibox,ibox+1)
     &    *exp_bltzmn)
      end do
 
!     modify rate constants for going down           

      do ibox = 1,nbox_tot-1
           exp_bltzmn=exp(deltaV(ibox,ibox+1)/(2*R*Temp)) 
           rc_tot(ibox+1,ibox) =(rc_total(ibox+1,ibox)
     &     /exp_bltzmn) 

      end do
      
      return
      end
      
!      
!    Subroutine which normalises distribution and calculates its equilibrium      
!      
               
      subroutine get_p_eqlbrm
      implicit doubleprecision (a-h,o-z)
      include 'arrays2.cm'
      
      p_norm=0.0d0
      do ibox=1,nbox
      p_norm=p_norm+p(ibox)
      end do
      p=p/p_norm
      
      p_eqlbrm=0.0d0
      p_eqlbrm(1)=1.0d0
      do ibox=2,nbox
!
!   rc_tot(m,m+1)   is the rate constant from left to right  (up)
!   rc_tot(m+1,m)   is the rate constant from right to left  (down)        
!         
      
      rc_up  =rc_tot(nmin+ibox-2,nmin+ibox-1)
      rc_down=rc_tot(nmin+ibox-1,nmin+ibox-2)
      p_eqlbrm(ibox)=(rc_up/rc_down)*p_eqlbrm(ibox-1)
      end do    
      
      p_norm=0.0d0
      do ibox=1,nbox
      p_norm=p_norm+p_eqlbrm(ibox)
      end do
      p_eqlbrm=p_eqlbrm/p_norm
            
      return
      end
